<!doctype html>
<html class="no-js">
<head>



<meta charset="utf-8">
<title>Learn Python the Hard Way</title>

<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
<link href="../css/style.min.css" rel="stylesheet">
<!-- http://www.socicon.com -->
<link href="../css/icons.css" rel="stylesheet">


</head>

<body class="baseline-grid-off book-site" id="top">




<header class="header" role="banner">
    <nav class="navbar navbar-full nav-brand-family">
        <div class="row middle-xs">
            <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org" class="waves-effect">Learn:</a></li>

                <li><a href="https://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>

                <li><a href="https://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>

                <li><a href="https://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>

                <li><a href="https://learncodethehardway.org/c/" class="waves-effect">C</a></li>

                <li><a href="https://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>

                <li><a href="https://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>

                <li><a href="https://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>

                <li><a href="https://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>

                <li><a href="https://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>

            </ul>
            <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
            </ul>

            <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
                <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
            </ul>

        </div>
    </nav>

    <nav class="navbar navbar-full nav-main" role="navigation">
        <div class="row between-xs center-xs middle-xs bare">
            <div class="col-xs-4 start-xs bare">
                <a href="ex39.html#" class="no-underline nav-trigger waves-effect" id="toc"><div class="transformer hamburcloser">
                        <div class="bar bar-t"></div>
                        <div class="bar bar-m-a"></div>
                        <div class="bar bar-m-b"></div>
                        <div class="bar bar-b"></div>
                </div><span class="nav-trigger_text show-sm-inline">Contents</span></a>
            </div>
            <div class="col-xs-4"><strong>&nbsp;</strong></div>
            <div class="col-xs-4 end-xs bare">
                <a href="https://helpthw.zendesk.com/hc/en-us" class="no-underline nav-trigger waves-effect" id="help"><div class="transformer questioncloser">
                        <div class="icon-question-mark"></div>
                </div><span class="nav-trigger_text show-sm-inline">Help</span></a>
            </div>
        </div>
    </nav>

</header>




<div class="wrapper">
    <div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
        <img src="../images/logo-python.svg" alt="Learn Python The Hard Way" class="logo">
    </div>

    <aside class="sidebar sidebar-left" role="complementary">
        <nav class="side-nav-container">
            <ol class="table-of-contents">
                <h3>Table of Contents</h3>
                <li><a href="preface.html">Preface</a></li>
                <li><a href="intro.html">The Hard Way Is Easier</a></li>
                <li><a href="ex0.html">Ex0: The Setup</a></li>
                <li><a href="ex1.html">Ex1: A Good First Program</a></li>
                <li><a href="ex2.html">Ex2: Comments And Pound Characters</a></li>
                <li><a href="ex3.html">Ex3: Numbers And Math</a></li>
                <li><a href="ex4.html">Ex4: Variables And Names</a></li>
                <li><a href="ex5.html">Ex5: More Variables And Printing</a></li>
                <li><a href="ex6.html">Ex6: Strings And Text</a></li>
                <li><a href="ex7.html">Ex7: More Printing</a></li>
                <li><a href="ex8.html">Ex8: Printing, Printing</a></li>
                <li><a href="ex9.html">Ex9: Printing, Printing, Printing</a></li>
                <li><a href="ex10.html">Ex10: What Was That?</a></li>
                <li><a href="ex11.html">Ex11: Asking Questions</a></li>
                <li><a href="ex12.html">Ex12: Prompting People</a></li>
                <li><a href="ex13.html">Ex13: Parameters, Unpacking, Variables</a></li>
                <li><a href="ex14.html">Ex14: Prompting And Passing</a></li>
                <li><a href="ex15.html">Ex15: Reading Files</a></li>
                <li><a href="ex16.html">Ex16: Reading And Writing Files</a></li>
                <li><a href="ex17.html">Ex17: More Files</a></li>
                <li><a href="ex18.html">Ex18: Names, Variables, Code, Functions</a></li>
                <li><a href="ex19.html">Ex19: Functions And Variables</a></li>
                <li><a href="ex20.html">Ex20: Functions And Files</a></li>
                <li><a href="ex21.html">Ex21: Functions Can Return Something</a></li>
                <li><a href="ex22.html">Ex22: What Do You Know So Far?</a></li>
                <li><a href="ex23.html">Ex23: Read Some Code</a></li>
                <li><a href="ex24.html">Ex24: More Practice</a></li>
                <li><a href="ex25.html">Ex25: Even More Practice</a></li>
                <li><a href="ex26.html">Ex26: Congratulations, Take A Test!</a></li>
                <li><a href="ex27.html">Ex27: Memorizing Logic</a></li>
                <li><a href="ex28.html">Ex28: Boolean Practice</a></li>
                <li><a href="ex29.html">Ex29: What If</a></li>
                <li><a href="ex30.html">Ex30: Else And If</a></li>
                <li><a href="ex31.html">Ex31: Making Decisions</a></li>
                <li><a href="ex32.html">Ex32: Loops And Lists</a></li>
                <li><a href="ex33.html">Ex33: While Loops</a></li>
                <li><a href="ex34.html">Ex34: Accessing Elements Of Lists</a></li>
                <li><a href="ex35.html">Ex35: Branches and Functions</a></li>
                <li><a href="ex36.html">Ex36: Designing and Debugging</a></li>
                <li><a href="ex37.html">Ex37: Symbol Review</a></li>
                <li><a href="ex38.html">Ex38: Doing Things To Lists</a></li>
                <li><a href="ex39.html">Ex39: Dictionaries, Oh Lovely Dictionaries</a></li>
                <li><a href="ex40.html">Ex40: Modules, Classes, And Objects</a></li>
                <li><a href="ex41.html">Ex41: Learning To Speak Object Oriented</a></li>
                <li><a href="ex42.html">Ex42: Is-A, Has-A, Objects, and Classes</a></li>
                <li><a href="ex43.html">Ex43: Gothons From Planet Percal #25</a></li>
                <li><a href="ex44.html">Ex44: Inheritance Vs. Composition</a></li>
                <li><a href="ex45.html">Ex45: You Make A Game</a></li>
                <li><a href="ex46.html">Ex46: A Project Skeleton</a></li>
                <li><a href="ex47.html">Ex47: Automated Testing</a></li>
                <li><a href="ex48.html">Ex48: Advanced User Input</a></li>
                <li><a href="ex49.html">Ex49: Making Sentences</a></li>
                <li><a href="ex50.html">Ex50: Your First Website</a></li>
                <li><a href="ex51.html">Ex51: Getting Input From A Browser</a></li>
                <li><a href="ex52.html">Ex52: The Start Of Your Web Game</a></li>
                <li><a href="advice.html">Advice From An Old Programmer</a></li>
                <li><a href="next.html">Next Steps</a></li>
                <li><a href="appendixa.html">Appendix A: Command Line Crash Course</a></li>
            </ol>
            <ul class="site-links">
                <h3>Learn the Hard Way</h3>
                <li><a href="ex39.html#" class="waves-effect"><i class="icon-information"></i> About LPTHW</a></li>
                <li><a href="ex39.html#" class="waves-effect"><i class="icon-question-mark"></i> Help &amp; Support</a></li>
                <li><a href="ex39.html#" class="waves-effect"><i class="socicon-twitter"></i> Follow us on Twitter</a></li>
            </ul>
        </nav>
        <div class="colophon text-center">
            <div class="intro">
                <p class="bare-bottom">
                The type for this book is set in 18px / 1.5
                <a href="https://www.google.com/fonts/specimen/Source+Serif+Pro">Adobe Serif</a>,
                <a href="https://www.google.com/fonts/specimen/Source+Sans+Pro">Sans</a>, and
                <a href="https://www.google.com/fonts/specimen/Source+Code+Pro">Code</a>.
                </p>
            </div>
            <div class="printers-mark">
                <div class="inscription">Docendo <i class="icon-repeat"></i> Discimus</div>
            </div>
        </div>
    </aside>

    <div class="overlay"></div>

    <main class="main python" role="main">
    <div class="main-container row center-xs">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">

            <div class="content">
                <!--- RST STARTS -->
                <h1 class="title">Exercise 39: Dictionaries, Oh Lovely Dictionaries</h1>
                <p>You are now going to learn about the Dictionary data structure in Python.  A Dictionary (or &quot;dict&quot;) is a way to store data just like a <tt class="docutils literal">list</tt>, but instead of using only numbers to get the data, you can use almost anything.  This lets you treat a <tt class="docutils literal">dict</tt> like it's a database for storing and organizing data.</p>
<p>Let's compare what can dicts can do to what lists can do.  You see, a list lets you do this:</p>
<div class="highlight"><pre><span></span><a name="python--ex39_pycon.py-idio-pycon-pyg.html-1"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">things</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;a&#39;</span><span class="p">,</span> <span class="s1">&#39;b&#39;</span><span class="p">,</span> <span class="s1">&#39;c&#39;</span><span class="p">,</span> <span class="s1">&#39;d&#39;</span><span class="p">]</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-2"></a><span class="gp">&gt;&gt;&gt; </span><span class="k">print</span> <span class="n">things</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-3"></a><span class="go">b</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-4"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">things</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;z&#39;</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-5"></a><span class="gp">&gt;&gt;&gt; </span><span class="k">print</span> <span class="n">things</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-6"></a><span class="go">z</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-7"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">things</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-8"></a><span class="go">[&#39;a&#39;, &#39;z&#39;, &#39;c&#39;, &#39;d&#39;]</span>
</pre></div><p>You can use numbers to &quot;index&quot; into a list, meaning you can use numbers to find out what's in lists.  You should know this about lists by now, but make sure you understand that you can <em>only</em> use numbers to get items out of a list.</p>
<p>What a <tt class="docutils literal">dict</tt> does is let you use <em>anything</em>, not just numbers.  Yes, a dict associates one thing to another, no matter what it is.  Take a look:</p>
<div class="highlight"><pre><span></span><a name="python--ex39_pycon.py-idio-pycon-pyg.html-1"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">stuff</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;name&#39;</span><span class="p">:</span> <span class="s1">&#39;Zed&#39;</span><span class="p">,</span> <span class="s1">&#39;age&#39;</span><span class="p">:</span> <span class="mi">39</span><span class="p">,</span> <span class="s1">&#39;height&#39;</span><span class="p">:</span> <span class="mi">6</span> <span class="o">*</span> <span class="mi">12</span> <span class="o">+</span> <span class="mi">2</span><span class="p">}</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-2"></a><span class="gp">&gt;&gt;&gt; </span><span class="k">print</span> <span class="n">stuff</span><span class="p">[</span><span class="s1">&#39;name&#39;</span><span class="p">]</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-3"></a><span class="go">Zed</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-4"></a><span class="gp">&gt;&gt;&gt; </span><span class="k">print</span> <span class="n">stuff</span><span class="p">[</span><span class="s1">&#39;age&#39;</span><span class="p">]</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-5"></a><span class="go">39</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-6"></a><span class="gp">&gt;&gt;&gt; </span><span class="k">print</span> <span class="n">stuff</span><span class="p">[</span><span class="s1">&#39;height&#39;</span><span class="p">]</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-7"></a><span class="go">74</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-8"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">stuff</span><span class="p">[</span><span class="s1">&#39;city&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s2">&quot;San Francisco&quot;</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-9"></a><span class="gp">&gt;&gt;&gt; </span><span class="k">print</span> <span class="n">stuff</span><span class="p">[</span><span class="s1">&#39;city&#39;</span><span class="p">]</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-10"></a><span class="go">San Francisco</span>
</pre></div><p>You will see that instead of just numbers we're using strings to say what we want from the <tt class="docutils literal">stuff</tt> dictionary.  We can also put new things into the dictionary with strings.  It doesn't have to be strings though. We can also do this:</p>
<div class="highlight"><pre><span></span><a name="python--ex39_pycon.py-idio-pycon-pyg.html-1"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">stuff</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">=</span> <span class="s2">&quot;Wow&quot;</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-2"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">stuff</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span> <span class="o">=</span> <span class="s2">&quot;Neato&quot;</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-3"></a><span class="gp">&gt;&gt;&gt; </span><span class="k">print</span> <span class="n">stuff</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-4"></a><span class="go">Wow</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-5"></a><span class="gp">&gt;&gt;&gt; </span><span class="k">print</span> <span class="n">stuff</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-6"></a><span class="go">Neato</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-7"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">stuff</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-8"></a><span class="go">{&#39;city&#39;: &#39;San Francisco&#39;, 2: &#39;Neato&#39;, &#39;name&#39;: &#39;Zed&#39;, 1: &#39;Wow&#39;, &#39;age&#39;: 39, &#39;height&#39;: 74}</span>
</pre></div><p>In this code I used numbers, and then you can see there are numbers and strings as keys in the dict when I print it.  I could use anything.  Well, almost but just pretend you can use anything for now.</p>
<p>Of course, a dictionary that you can only put things in is pretty stupid, so here's how you delete things, with the <tt class="docutils literal">del</tt> keyword:</p>
<div class="highlight"><pre><span></span><a name="python--ex39_pycon.py-idio-pycon-pyg.html-1"></a><span class="gp">&gt;&gt;&gt; </span><span class="k">del</span> <span class="n">stuff</span><span class="p">[</span><span class="s1">&#39;city&#39;</span><span class="p">]</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-2"></a><span class="gp">&gt;&gt;&gt; </span><span class="k">del</span> <span class="n">stuff</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-3"></a><span class="gp">&gt;&gt;&gt; </span><span class="k">del</span> <span class="n">stuff</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-4"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">stuff</span>
<a name="python--ex39_pycon.py-idio-pycon-pyg.html-5"></a><span class="go">{&#39;name&#39;: &#39;Zed&#39;, &#39;age&#39;: 39, &#39;height&#39;: 74}</span>
</pre></div><div class="section" id="a-dictionary-example">
<h1>A Dictionary Example</h1>
<p>We'll now do an exercise that you <em>must</em> study very carefully.  I want you to type this code in and try to understand what's going on.  Take note of when you put things in a dict, get from a hash, and all the operations you use.  Notice how this example is mapping states to their abbreviations, and then the abbreviations to cities in the states.  Remember, &quot;mapping&quot; or &quot;associating&quot; is the key concept in a dictionary.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex39.py-idio.html-1"></a><span class="c1"># create a mapping of state to abbreviation</span>
<a name="python--ex39.py-idio.html-2"></a><span class="n">states</span> <span class="o">=</span> <span class="p">{</span>
<a name="python--ex39.py-idio.html-3"></a>    <span class="s1">&#39;Oregon&#39;</span><span class="p">:</span> <span class="s1">&#39;OR&#39;</span><span class="p">,</span>
<a name="python--ex39.py-idio.html-4"></a>    <span class="s1">&#39;Florida&#39;</span><span class="p">:</span> <span class="s1">&#39;FL&#39;</span><span class="p">,</span>
<a name="python--ex39.py-idio.html-5"></a>    <span class="s1">&#39;California&#39;</span><span class="p">:</span> <span class="s1">&#39;CA&#39;</span><span class="p">,</span>
<a name="python--ex39.py-idio.html-6"></a>    <span class="s1">&#39;New York&#39;</span><span class="p">:</span> <span class="s1">&#39;NY&#39;</span><span class="p">,</span>
<a name="python--ex39.py-idio.html-7"></a>    <span class="s1">&#39;Michigan&#39;</span><span class="p">:</span> <span class="s1">&#39;MI&#39;</span>
<a name="python--ex39.py-idio.html-8"></a><span class="p">}</span>
<a name="python--ex39.py-idio.html-9"></a>
<a name="python--ex39.py-idio.html-10"></a><span class="c1"># create a basic set of states and some cities in them</span>
<a name="python--ex39.py-idio.html-11"></a><span class="n">cities</span> <span class="o">=</span> <span class="p">{</span>
<a name="python--ex39.py-idio.html-12"></a>    <span class="s1">&#39;CA&#39;</span><span class="p">:</span> <span class="s1">&#39;San Francisco&#39;</span><span class="p">,</span>
<a name="python--ex39.py-idio.html-13"></a>    <span class="s1">&#39;MI&#39;</span><span class="p">:</span> <span class="s1">&#39;Detroit&#39;</span><span class="p">,</span>
<a name="python--ex39.py-idio.html-14"></a>    <span class="s1">&#39;FL&#39;</span><span class="p">:</span> <span class="s1">&#39;Jacksonville&#39;</span>
<a name="python--ex39.py-idio.html-15"></a><span class="p">}</span>
<a name="python--ex39.py-idio.html-16"></a>
<a name="python--ex39.py-idio.html-17"></a><span class="c1"># add some more cities</span>
<a name="python--ex39.py-idio.html-18"></a><span class="n">cities</span><span class="p">[</span><span class="s1">&#39;NY&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;New York&#39;</span>
<a name="python--ex39.py-idio.html-19"></a><span class="n">cities</span><span class="p">[</span><span class="s1">&#39;OR&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;Portland&#39;</span>
<a name="python--ex39.py-idio.html-20"></a>
<a name="python--ex39.py-idio.html-21"></a><span class="c1"># print out some cities</span>
<a name="python--ex39.py-idio.html-22"></a><span class="k">print</span> <span class="s1">&#39;-&#39;</span> <span class="o">*</span> <span class="mi">10</span>
<a name="python--ex39.py-idio.html-23"></a><span class="k">print</span> <span class="s2">&quot;NY State has: &quot;</span><span class="p">,</span> <span class="n">cities</span><span class="p">[</span><span class="s1">&#39;NY&#39;</span><span class="p">]</span>
<a name="python--ex39.py-idio.html-24"></a><span class="k">print</span> <span class="s2">&quot;OR State has: &quot;</span><span class="p">,</span> <span class="n">cities</span><span class="p">[</span><span class="s1">&#39;OR&#39;</span><span class="p">]</span>
<a name="python--ex39.py-idio.html-25"></a>
<a name="python--ex39.py-idio.html-26"></a><span class="c1"># print some states</span>
<a name="python--ex39.py-idio.html-27"></a><span class="k">print</span> <span class="s1">&#39;-&#39;</span> <span class="o">*</span> <span class="mi">10</span>
<a name="python--ex39.py-idio.html-28"></a><span class="k">print</span> <span class="s2">&quot;Michigan&#39;s abbreviation is: &quot;</span><span class="p">,</span> <span class="n">states</span><span class="p">[</span><span class="s1">&#39;Michigan&#39;</span><span class="p">]</span>
<a name="python--ex39.py-idio.html-29"></a><span class="k">print</span> <span class="s2">&quot;Florida&#39;s abbreviation is: &quot;</span><span class="p">,</span> <span class="n">states</span><span class="p">[</span><span class="s1">&#39;Florida&#39;</span><span class="p">]</span>
<a name="python--ex39.py-idio.html-30"></a>
<a name="python--ex39.py-idio.html-31"></a><span class="c1"># do it by using the state then cities dict</span>
<a name="python--ex39.py-idio.html-32"></a><span class="k">print</span> <span class="s1">&#39;-&#39;</span> <span class="o">*</span> <span class="mi">10</span>
<a name="python--ex39.py-idio.html-33"></a><span class="k">print</span> <span class="s2">&quot;Michigan has: &quot;</span><span class="p">,</span> <span class="n">cities</span><span class="p">[</span><span class="n">states</span><span class="p">[</span><span class="s1">&#39;Michigan&#39;</span><span class="p">]]</span>
<a name="python--ex39.py-idio.html-34"></a><span class="k">print</span> <span class="s2">&quot;Florida has: &quot;</span><span class="p">,</span> <span class="n">cities</span><span class="p">[</span><span class="n">states</span><span class="p">[</span><span class="s1">&#39;Florida&#39;</span><span class="p">]]</span>
<a name="python--ex39.py-idio.html-35"></a>
<a name="python--ex39.py-idio.html-36"></a><span class="c1"># print every state abbreviation</span>
<a name="python--ex39.py-idio.html-37"></a><span class="k">print</span> <span class="s1">&#39;-&#39;</span> <span class="o">*</span> <span class="mi">10</span>
<a name="python--ex39.py-idio.html-38"></a><span class="k">for</span> <span class="n">state</span><span class="p">,</span> <span class="n">abbrev</span> <span class="ow">in</span> <span class="n">states</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
<a name="python--ex39.py-idio.html-39"></a>    <span class="k">print</span> <span class="s2">&quot;</span><span class="si">%s</span><span class="s2"> is abbreviated </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">state</span><span class="p">,</span> <span class="n">abbrev</span><span class="p">)</span>
<a name="python--ex39.py-idio.html-40"></a>
<a name="python--ex39.py-idio.html-41"></a><span class="c1"># print every city in state</span>
<a name="python--ex39.py-idio.html-42"></a><span class="k">print</span> <span class="s1">&#39;-&#39;</span> <span class="o">*</span> <span class="mi">10</span>
<a name="python--ex39.py-idio.html-43"></a><span class="k">for</span> <span class="n">abbrev</span><span class="p">,</span> <span class="n">city</span> <span class="ow">in</span> <span class="n">cities</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
<a name="python--ex39.py-idio.html-44"></a>    <span class="k">print</span> <span class="s2">&quot;</span><span class="si">%s</span><span class="s2"> has the city </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">abbrev</span><span class="p">,</span> <span class="n">city</span><span class="p">)</span>
<a name="python--ex39.py-idio.html-45"></a>
<a name="python--ex39.py-idio.html-46"></a><span class="c1"># now do both at the same time</span>
<a name="python--ex39.py-idio.html-47"></a><span class="k">print</span> <span class="s1">&#39;-&#39;</span> <span class="o">*</span> <span class="mi">10</span>
<a name="python--ex39.py-idio.html-48"></a><span class="k">for</span> <span class="n">state</span><span class="p">,</span> <span class="n">abbrev</span> <span class="ow">in</span> <span class="n">states</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
<a name="python--ex39.py-idio.html-49"></a>    <span class="k">print</span> <span class="s2">&quot;</span><span class="si">%s</span><span class="s2"> state is abbreviated </span><span class="si">%s</span><span class="s2"> and has city </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span>
<a name="python--ex39.py-idio.html-50"></a>        <span class="n">state</span><span class="p">,</span> <span class="n">abbrev</span><span class="p">,</span> <span class="n">cities</span><span class="p">[</span><span class="n">abbrev</span><span class="p">])</span>
<a name="python--ex39.py-idio.html-51"></a>
<a name="python--ex39.py-idio.html-52"></a><span class="k">print</span> <span class="s1">&#39;-&#39;</span> <span class="o">*</span> <span class="mi">10</span>
<a name="python--ex39.py-idio.html-53"></a><span class="c1"># safely get a abbreviation by state that might not be there</span>
<a name="python--ex39.py-idio.html-54"></a><span class="n">state</span> <span class="o">=</span> <span class="n">states</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;Texas&#39;</span><span class="p">)</span>
<a name="python--ex39.py-idio.html-55"></a>
<a name="python--ex39.py-idio.html-56"></a><span class="k">if</span> <span class="ow">not</span> <span class="n">state</span><span class="p">:</span>
<a name="python--ex39.py-idio.html-57"></a>    <span class="k">print</span> <span class="s2">&quot;Sorry, no Texas.&quot;</span>
<a name="python--ex39.py-idio.html-58"></a>
<a name="python--ex39.py-idio.html-59"></a><span class="c1"># get a city with a default value</span>
<a name="python--ex39.py-idio.html-60"></a><span class="n">city</span> <span class="o">=</span> <span class="n">cities</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;TX&#39;</span><span class="p">,</span> <span class="s1">&#39;Does Not Exist&#39;</span><span class="p">)</span>
<a name="python--ex39.py-idio.html-61"></a><span class="k">print</span> <span class="s2">&quot;The city for the state &#39;TX&#39; is: </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="n">city</span>
</pre></div>
</td></tr></table></div>
<div class="section" id="what-you-should-see">
<h1>What You Should See</h1>
<div class="highlight"><pre><span></span><a name="python--ex39.sh-idio-shint-pyg.html-1"></a><span class="gp">$</span> python ex39.py
<a name="python--ex39.sh-idio-shint-pyg.html-2"></a><span class="go">----------</span>
<a name="python--ex39.sh-idio-shint-pyg.html-3"></a><span class="go">NY State has:  New York</span>
<a name="python--ex39.sh-idio-shint-pyg.html-4"></a><span class="go">OR State has:  Portland</span>
<a name="python--ex39.sh-idio-shint-pyg.html-5"></a><span class="go">----------</span>
<a name="python--ex39.sh-idio-shint-pyg.html-6"></a><span class="go">Michigan&#39;s abbreviation is:  MI</span>
<a name="python--ex39.sh-idio-shint-pyg.html-7"></a><span class="go">Florida&#39;s abbreviation is:  FL</span>
<a name="python--ex39.sh-idio-shint-pyg.html-8"></a><span class="go">----------</span>
<a name="python--ex39.sh-idio-shint-pyg.html-9"></a><span class="go">Michigan has:  Detroit</span>
<a name="python--ex39.sh-idio-shint-pyg.html-10"></a><span class="go">Florida has:  Jacksonville</span>
<a name="python--ex39.sh-idio-shint-pyg.html-11"></a><span class="go">----------</span>
<a name="python--ex39.sh-idio-shint-pyg.html-12"></a><span class="go">California is abbreviated CA</span>
<a name="python--ex39.sh-idio-shint-pyg.html-13"></a><span class="go">Michigan is abbreviated MI</span>
<a name="python--ex39.sh-idio-shint-pyg.html-14"></a><span class="go">New York is abbreviated NY</span>
<a name="python--ex39.sh-idio-shint-pyg.html-15"></a><span class="go">Florida is abbreviated FL</span>
<a name="python--ex39.sh-idio-shint-pyg.html-16"></a><span class="go">Oregon is abbreviated OR</span>
<a name="python--ex39.sh-idio-shint-pyg.html-17"></a><span class="go">----------</span>
<a name="python--ex39.sh-idio-shint-pyg.html-18"></a><span class="go">FL has the city Jacksonville</span>
<a name="python--ex39.sh-idio-shint-pyg.html-19"></a><span class="go">CA has the city San Francisco</span>
<a name="python--ex39.sh-idio-shint-pyg.html-20"></a><span class="go">MI has the city Detroit</span>
<a name="python--ex39.sh-idio-shint-pyg.html-21"></a><span class="go">OR has the city Portland</span>
<a name="python--ex39.sh-idio-shint-pyg.html-22"></a><span class="go">NY has the city New York</span>
<a name="python--ex39.sh-idio-shint-pyg.html-23"></a><span class="go">----------</span>
<a name="python--ex39.sh-idio-shint-pyg.html-24"></a><span class="go">California state is abbreviated CA and has city San Francisco</span>
<a name="python--ex39.sh-idio-shint-pyg.html-25"></a><span class="go">Michigan state is abbreviated MI and has city Detroit</span>
<a name="python--ex39.sh-idio-shint-pyg.html-26"></a><span class="go">New York state is abbreviated NY and has city New York</span>
<a name="python--ex39.sh-idio-shint-pyg.html-27"></a><span class="go">Florida state is abbreviated FL and has city Jacksonville</span>
<a name="python--ex39.sh-idio-shint-pyg.html-28"></a><span class="go">Oregon state is abbreviated OR and has city Portland</span>
<a name="python--ex39.sh-idio-shint-pyg.html-29"></a><span class="go">----------</span>
<a name="python--ex39.sh-idio-shint-pyg.html-30"></a><span class="go">Sorry, no Texas.</span>
<a name="python--ex39.sh-idio-shint-pyg.html-31"></a><span class="go">The city for the state &#39;TX&#39; is: Does Not Exist</span>
</pre></div></div>
<div class="section" id="what-dictionaries-can-do">
<h1>What Dictionaries Can Do</h1>
<p>Dictionaries are another example of a data structure, and like lists they are one of the most commonly used data structures in programming.  A dictionary is used to <em>map</em> or <em>associate</em> things you want to store to keys you need to get them.  Again, programmers don't use a term like &quot;dictionary&quot; for something that doesn't work like an actual dictionary full of words, so let's use that as our real world example.</p>
<p>Let's say you want to find out what the word &quot;Honorificabilitudinitatibus&quot; means.  Today you would simply copy-paste that word into a search engine and then find out the answer, and we could say a search engine is like a really huge super complex version of the <em>Oxford English Dictionary</em> (OED).  Before search engines what you would do is this:</p>
<ol class="arabic simple">
<li>Go to your library and get &quot;the dictionary&quot;. Let's say it's the OED.</li>
<li>You know &quot;honorificabilitudinitatibus&quot; starts with the letter 'H' so you look on the side of the book for the little tab that has 'H' on it.</li>
<li>Then you'd skim the pages until you are close to where &quot;hon&quot; started.</li>
<li>Then you'd skim a few more pages until you found &quot;honorificabilitudinitatibus&quot; or hit the beginning of the &quot;hp&quot; words and realize this word isn't in the OED.</li>
<li>Once you found the entry, you'd read the definition to figure out what it means.</li>
</ol>
<p>This process is nearly exactly the way a dict works, and you are basically &quot;mapping&quot; the word &quot;honorificabilitudinitatibus&quot; to its definition.  A dict in Python is just like a dictionary in the real world like the OED.</p>
</div>
<div class="section" id="study-drills">
<h1>Study Drills</h1>
<ol class="arabic simple">
<li>Do this same kind of mapping with cities and states/regions in your country or some other country.</li>
<li>Find the Python documentation for dictionaries and try to do even more things to them.</li>
<li>Find out what you <em>can't</em> do with dictionaries.  A big one is that they do not have order, so try playing with that.</li>
</ol>
</div>
<div class="section" id="common-student-questions">
<h1>Common Student Questions</h1>
<dl class="docutils">
<dt>What is the difference between a list and a dictionary?</dt>
<dd>A list is for an ordered list of items.  A dictionary (or <tt class="docutils literal">dict</tt>) is for matching some items (called &quot;keys&quot;) to other items (called &quot;values&quot;).</dd>
<dt>What would I use a dictionary for?</dt>
<dd>When you have to take one value and &quot;look up&quot; another value.  In fact you could call dictionaries &quot;look up tables.&quot;</dd>
<dt>What would I use a list for?</dt>
<dd>Use a list for any sequence of things that need to be in order, and you only need to look them up by a numeric index.</dd>
<dt>What if I need a dictionary, but I need it to be in order?</dt>
<dd>Take a look at the <tt class="docutils literal">collections.OrderedDict</tt> data structure in Python.  Search for it online to find the documentation.</dd>
</dl>
</div>
                <!-- RST ENDS -->
            </div>
        </div>

        <div class="row center-xs" id="buy">
            <div class="text-center col-xs-10 col-sm-5 col-md-4">
                <h2 class="section-title__small">Buy The Python 2 Course</h2>
                <p>
                When you buy directly from the author, Zed A. Shaw, you'll get a professional
                quality PDF and  hours of HD Video, all DRM-free and yours to download.
                </p>

                <p class="price-block">
                <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
                </p>

                <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy The Python 2 Course</a>
                <a href="https://shop.learncodethehardway.org/access/buy/9/" class="btn btn-primary btn-full">Pre-Order The Python 3 Course Instead</a>

                <p class="text-left btn-subtext">
                <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
                </p>

            </div>
            <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">

                <h2 class="section-title__small">Other Buying Options</h2>
                <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
                <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from the Publisher</a>
                <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>

            </div>
        </div>
    </div>

    <div class="row center-xs" id="video_holder" style="display: none">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">
            <div data-paydiv_product="2" id='paydiv'>
                No content available for this exercise.  You can view all available downloads at <a href="https://shop.learncodethehardway.org/customers/">your customer account page</a>.
            </div>
        </div>
    </div>
    </main>

</div>

<div class="row dark bottom-nav">
    <div class="col-xs text-left">
        <a href="ex39.html" class="prev" id='prev_link'><i class="icon-arrow-67"></i> <i class="icon icon-arrow-left"></i> Previous <span class="hide-xs show-sm-inline">Lesson</span></a>
    </div>
    <div class="col-xs text-right"><a href="ex39.html" class="next" id='next_link'>Next <span class="hide-xs show-sm-inline">Lesson</span> <i class="icon icon-arrow-right"></i></a>
    </div>
</div>
  </div>

<footer class="footer">
<div class="row center-xs">

    <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
        <ul class="nav nav-inline">
            <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
        </ul>
        <div class="copyright text-left">
            <small class="text-muted">&copy; 2016 Zed A. Shaw. All rights reserved.</small>
        </div>
    </div>
    <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
        <div class="social-media">
            <div class="classy-container">
                <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
            </div>
        </div>
    </div>
</div>

</footer>
<script src="../js/scripts.min.js"></script>

<script src="javascripts/jquery.js"></script>
<script src="index.js"></script>
<script src="https://shop.learncodethehardway.org/static/jzed.js"></script>
<script src="https://shop.learncodethehardway.org/static/js/videojs/video.js"></script>
<link rel="stylesheet" href="https://shop.learncodethehardway.org/static/js/videojs/video-js.css">
<script src="https://shop.learncodethehardway.org/static/api/v1/paydiv.js"></script>
<script src="javascripts/app.js"></script>
<script src="javascripts/littools.js"></script>
<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
 (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
 m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
 })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-24168052-1', 'auto');
ga('send', 'pageview');

</script>

</body>
</html>
